﻿var paperWidth = 792;
var paperHeight = 1122;
var mLeft = mRight = mTop = mBottom = 96;
var pageMargin = 12;
var pageCount = 1;

function Print() {
    var html = window.document.body.innerHTML;
    var mdiv = document.getElementById("maindiv");
    window.document.body.innerHTML = mdiv.innerHTML;
    window.print();
    window.document.body.innerHTML = html;
}

function bodyLoad() {
    Paging();
    setPageBorder();
}

function setPageBorder() {
    var px = "px";
    var width = document.body.clientWidth;
    if (width == 0) {
        width = screen.width;
    }
    var left = (width - paperWidth) / 2;
    var pageBorderDiv = document.getElementById("pageBorderDiv");
    pageBorderDiv.style.position = "absolute";
    pageBorderDiv.style.marginLeft = left + px;
    pageBorderDiv.style.marginRight = left + px;
    pageBorderDiv.style.width = paperWidth + px;
    pageBorderDiv.style.height = paperHeight * pageCount + (pageCount - 1) * pageMargin + px;
    pageBorderDiv.style.zIndex = -1;
    while (pageBorderDiv.children.length > 0) {
        var child = pageBorderDiv.firstChild;
        pageBorderDiv.removeChild(child);
    }
    for (var i = 0; i < pageCount; i++) {
        var div = document.createElement("div");
        div.setAttribute("id", "page" + i);
        div.style.margin = 0 + px;
        div.style.padding = 0 + px;
        div.style.width = paperWidth + px;
        div.style.height = paperHeight + px;
        div.style.marginBottom = (pageMargin - 2) + px;
        div.style.border = "1px solid black";
        pageBorderDiv.appendChild(div);
    }
}
var tbEnd = '</table>', rowBeign = '<tr>', rowEnd = '</tr>', tdBegin = '<td>', tdEnd = '</td>';

//分页处理 
var dataTables = new Array();
function GetSourceTables() {
    dataTables = [];
    var tempTables = document.getElementsByTagName("table");
    var rowlen, collen, rowStr;

    for (var i = 0; i < tempTables.length; i++) {
        if (tempTables[i].id == '' || tempTables[i].id == null)
            continue;
        rowlen = tempTables[i].rows.length;
        collen = tempTables[i].rows[0].cells.length;
        var dataItem = new Object(), rows = new Array();
        for (var j = 0; j < rowlen; j++) {
            rowStr = '';
            var row = new Object();
            for (var k = 0; k < collen; k++) {
                rowStr += tempTables[i].rows[j].cells[k].outerHTML;
            }
            row.rowstr = rowStr;
            row.rowheight = tempTables[i].rows[j].cells[0].offsetHeight;
            rows.push(row);
        }
        dataItem.id = tempTables[i].id;
        dataItem.rows = rows;
        dataTables.push(dataItem);
    }
}

function Paging() {
    var pageIndex = 0, height = 0, nextRowHight = 0;
    var headerDivHeight = headerdiv.offsetHeight;
    var footerDivHeight = footerdiv.offsetHeight + 22;
    if (headerDivHeight > mTop) mTop = headerDivHeight;
    if (footerDivHeight > mBottom) mBottom = footerDivHeight;
    var pw = paperWidth - mLeft - mRight;
    var ph = paperHeight - mTop - mBottom;
    var IsApproveRecord = false; //是否是审批记录

    var titleDiv = '<div style="margin:10px 0px;">' + titlediv.innerHTML + '</div>'; height += 20;
    var beginDiv = '<div>' + begindiv.innerHTML + '</div>';
    var pageDiv = '<div style="width:' + paperWidth + 'px;height:' + paperHeight + 'px; margin:auto;margin-top:0px;margin-bottom:0px;padding:0px;"><div style="width:' + pw + 'px;height:' + paperHeight + 'px;margin-top:0px;margin-bottom:0px;padding:0px;margin-left:' + mLeft + 'px;margin-right:' + mRight + 'px;">';
    var pageHeaderDiv = '<div style="height:' + mTop + 'px;"><div style="position:relative;top:' + (mTop - headerDivHeight) + 'px">' + headerdiv.innerHTML + '</div></div>';
    var pageBreakDiv = '<div class="noprint" style="margin:0px;padding:0px;width:' + paperWidth + 'px;height:' + pageMargin + 'px;"></div>';
    var pageBodyDiv = '<div style="height:' + ph + 'px">';
    var tbBegin = '<table style="width:' + pw + 'px;margin:auto;" cellpadding="0" cellspacing="0">';
    var html = pageDiv + pageHeaderDiv + pageBodyDiv + titleDiv + beginDiv;
    height += begindiv.offsetHeight + titlediv.offsetHeight;

    GetSourceTables();

    if (dataTables.length > 0) {
        for (var k = 0; k < dataTables.length; k++) {
            var table = dataTables[k];
            //judge start new page
            if (table.id == 'ApprTable') {
                if (height > 0) {
                    height = 0;
                    pageIndex++;
                    IsApproveRecord = true;
                    var pageFooterDiv = '<div style="width:' + pw + 'px;height:' + mBottom + 'px;">' + footerdiv.innerHTML + '<div style="text-align:center;">第' + pageIndex + '页</div></div>';
                    html += tbEnd + "</div>" + pageFooterDiv + "</div></div>" + pageBreakDiv;
                }
                html += pageDiv + pageHeaderDiv + pageBodyDiv;
            }
            //judge start new page  
            var args = this.opener.document.args;
            if (args != null && args[k] != null) {
                height += 60;
                html += '<div style="width:' + pw + 'px;height:30px; margin-top:30px; ">' + args[k] + '</div>';
            }
            if (IsApproveRecord) {
                height += 60;
                html += '<div style="width:' + pw + 'px;height:30px; margin-top:30px 0px; font-size:20px; text-align:center">审批历史记录</div>';
                html += '<table  id="ApprTable" style="width:' + pw + 'px;margin:auto;" cellpadding="0" cellspacing="0">';
            }
            else {
                html += tbBegin;
            }
            var rowCount = table.rows.length;
            for (var i = 0; i < rowCount; i++) {
                html += rowBeign + table.rows[i].rowstr + rowEnd;
                height += table.rows[i].rowheight;
                if (i + 1 < rowCount) {
                    nextRowHight = table.rows[i + 1].rowheight;
                }
                else if (i + 1 == rowCount && (k < dataTables.length - 1)) {
                    var nexRow = dataTables[k + 1].rows[0];
                    if (nexRow != null) {
                        nextRowHight = nexRow.rowheight;
                    }
                    else {
                        nextRowHight = 0;
                    }
                }
                else {
                    nextRowHight = 0;
                }
                var delta = paperHeight - height - mTop - mBottom;
                if (delta < nextRowHight) {
                    height = 0;
                    pageIndex++;
                    var pageFooterDiv = '<div style="width:' + pw + 'px;height:' + mBottom + 'px;">' + footerdiv.innerHTML + '<div style="text-align:center;">第' + pageIndex + '页</div></div>';
                    html += tbEnd + "</div>" + pageFooterDiv + "</div></div>" + pageBreakDiv;
                    if (i < rowCount - 1)
                        html += pageDiv + pageHeaderDiv + pageBodyDiv + tbBegin;
                }
            }
            html += tbEnd;
        }
        //某个表所有行结束后如果高度未完
        if (height > 0) {
            pageIndex++;
            var pageFooterDiv = '<div style="width:' + pw + 'px;height:' + mBottom + 'px;">' + footerdiv.innerHTML + '<div style="text-align:center;">第' + pageIndex + '页</div></div>';
            html += tbEnd + "</div>" + pageFooterDiv + "</div></div>";
        }
    }
    else {
        pageIndex++;
        var pageFooterDiv = '<div style="width:' + pw + 'px;height:' + mBottom + 'px;">' + footerdiv.innerHTML + '<div style="text-align:center;">第' + pageIndex + '页</div></div>';
        html += "</div>" + pageFooterDiv + "</div></div>";
    }

    var div = document.getElementById("maindiv");
    var pagecss = '<style>@page{size:' + paperWidth + 'px ' + paperHeight + 'px;margin:0px;padding:0px;orphans:0px;widows:0px;mso-header-margin:0px;mso-footer-margin:0px;}</style>';
    html = pagecss + html;
    div.innerHTML = html;
    pageCount = pageIndex;
}

function ResizePage() {
    var hdiv = document.getElementById("headerdiv");
    var bdiv = document.getElementById("begindiv");
    var fdiv = document.getElementById("footerdiv");
    var mdiv = document.getElementById("maindiv");
    var titlediv = document.getElementById("titlediv");
    var pw = this.paperWidth - mLeft - mRight;
    var ph = this.paperHeight - mTop - mBottom;
    var tableStr = '', html = '<div style="margin:auto; width:' + pw + 'px;">' + hdiv.innerHTML + bdiv.innerHTML + '</div>';
    for (var k = 0; k < dataTables.length; k++) {
        tableStr += '<table id="' + dataTables[k].id + '" cellpadding="0" cellspacing="0" style="width:' + pw + 'px; margin:auto;">';
        for (var i = 0; i < dataTables[k].rows.length; i++) {
            tableStr += rowBeign + dataTables[k].rows[i].rowstr + rowEnd;
        }
        tableStr += tbEnd;
    }
    html += tableStr + '<div style="width:' + pw + 'px; margin:auto;>' + fdiv.innerHTML + '</div>';
    mdiv.innerHTML = html;
    Paging();
}

function inputChanged(tb) {
    if (isNaN(tb.value)) {
        tb.value = 2.54;
    }
}

function calculatePix(value) {
    return parseInt(value * 96 / 2.54);
}

function calcPageSize() {
    var ps = this.document.getElementById("PageSizeSelect");
    var value = ps.value;
    var pHor = this.document.getElementById("pHor");
    var pTop = this.document.getElementById("pTop");
    var pDown = this.document.getElementById("pDown");
    var pLeft = this.document.getElementById("pLeft");
    var pRight = this.document.getElementById("pRight");
    var Hor = false;
    if (pHor.checked) {
        Hor = true;
    }
    var width = 0;
    var height = 0;
    var top = calculatePix(pTop.value);
    var down = calculatePix(pDown.value);
    var left = calculatePix(pLeft.value);
    var right = calculatePix(pRight.value);
    if (value.indexOf("A4") >= 0) {
        width = calculatePix(21);
        height = calculatePix(29.7);
    }
    else if (value.indexOf("B5") >= 0) {
        width = calculatePix(18.2);
        height = calculatePix(25.7);
    }
    else if (value.indexOf("16开") >= 0) {
        width = calculatePix(18.4);
        height = calculatePix(26);
    }
    if (Hor) {
        var temp = width; width = height;
        height = temp;
    }
    this.paperWidth = width;
    this.paperHeight = height;
    this.mTop = top;
    this.mLeft = left;
    this.mRight = right;
    this.mBottom = down;
}

function closeMask() {
    var tooldiv = document.getElementById("toolbarDiv");
    tooldiv.style.display = "block";
    var setdiv = document.getElementById("settingDiv");
    setdiv.style.display = "none";
    document.body.style.overflow = "auto"; //恢复页面滚动条
    var body = document.getElementsByTagName("body");
    var maskdiv = document.getElementById("maskdiv");
    body[0].removeChild(maskdiv);
}
function OK() {
    closeMask();
    calcPageSize();
    ResizePage();
    setPageBorder();
    // MyDragEvent();
}

function showDiv() {
    var tooldiv = document.getElementById("toolbarDiv");
    tooldiv.style.display = "none";
    var setdiv = document.getElementById("settingDiv");
    setdiv.style.display = "block";
    //以下部分要将弹出层居中显示
    var scrollTop = document.documentElement.scrollTop || document.body.scrollTop;
    var scrollLeft = document.documentElement.scrollLeft || document.body.scrollLeft;
    setdiv.style.left = (document.documentElement.clientWidth - setdiv.clientWidth) / 2 + scrollLeft + "px";
    setdiv.style.top = (document.documentElement.clientHeight - setdiv.clientHeight) / 2 + scrollTop - 50 + "px";

    //以下部分使整个页面至灰不可点击
    var maskdiv = document.createElement("div"); //首先创建一个div
    maskdiv.setAttribute("id", "maskdiv"); //定义该div的id
    maskdiv.style.background = "#000000";
    maskdiv.style.width = "100%";
    maskdiv.style.height = "100%";
    maskdiv.style.position = "fixed";
    maskdiv.style.top = "0";
    maskdiv.style.left = "0";
    maskdiv.style.opacity = "0.6";
    maskdiv.style.filter = "Alpha(opacity=40)";
    //背景层加入页面
    document.body.appendChild(maskdiv);
    //取消滚动条 
    document.body.style.overflow = "hidden";
    //以下部分实现弹出层的拖拽效果
    var posX, posY;
    var menuDiv = document.getElementById("menuDiv");
    menuDiv.onmousedown = function (e) {
        if (!e) e = window.event; //IE
        posX = e.clientX - parseInt(setdiv.style.left);
        posY = e.clientY - parseInt(setdiv.style.top);
        document.onmousemove = mousemove;
    }
    document.onmouseup = function () {
        document.onmousemove = null;
    }
    function mousemove(ev) {
        if (ev == null) ev = window.event; //IE
        setdiv.style.left = (ev.clientX - posX) + "px";
        setdiv.style.top = (ev.clientY - posY) + "px";
    }
}

var resizing = false;
var marginLeft = 0; //左边距离body的像素
var obj = null;

function MyDragEvent() {
    var tables = document.getElementsByTagName("table");
    for (var j = 0; j < tables.length; j++) {
        var table = tables[j];
        if (table.id == null || table.id == '')
            continue;
        var cells = table.rows[0].cells;
        for (var i = 0; i < cells.length; i++) {
            cells[i].onmousemove = MouseMove;
            cells[i].onmousedown = MouseDown;
            cells[i].onmouseup = MouseUp;
        }
    }
}
function GetPos(obj) {
    var x = obj.clientWidth;
    if (x > 0) {
        if (obj.previousSibling != null) {
            x += GetPos(obj.previousSibling);
        }
    }
    else x = 0;
    return x;
}

function MouseDown() {
    obj = event.srcElement;
    var width = GetPos(obj);
    var marginLeft = event.srcElement.offsetParent.offsetLeft;
    var delta = Math.abs(event.clientX - width - marginLeft);
    if (delta <= 10) {// || event.offsetX <= 10) {
        obj.style.cursor = "w-resize";
        resizing = true;
        obj.mouseDownX = event.clientX;
        obj.previewWidth = obj.clientWidth;
        obj.setCapture();
    }
}

function MouseMove() {
    if (!resizing) {
        var width = GetPos(event.srcElement)
        var marginLeft = event.srcElement.offsetParent.offsetLeft;
        var delta = Math.abs(event.clientX - width - marginLeft);
        if (delta <= 10) {// || event.offsetX <= 10) {
            event.srcElement.style.cursor = "w-resize";
        }
        else {
            event.srcElement.style.cursor = "default";
        }
    }
    else {
        if (obj != null && obj.mouseDownX) {
            var deltaX = event.clientX - obj.mouseDownX; //鼠标两次坐标的偏移量
            var right = GetPos(obj);
            var newWidth = obj.previewWidth + deltaX;
            if (newWidth <= 0) return;
            obj.style.pixelWidth = newWidth;
            if (obj.nextSibling != null) {
                var pWidth = obj.nextSibling.clientWidth;
                pWidth -= deltaX;
                if (pWidth > 0) {
                    obj.nextSibling.style.pixelWidth = pWidth;
                }
            }
        }
    }
}

function MouseUp() {
    resizing = false;
    if (obj != null)
        obj.releaseCapture();
}
document.onmouseup = MouseUp;
