﻿<%@ Page Language="C#" Inherits="System.Web.Mvc.ViewPage<dynamic>" %>

<%@ Register Namespace="Ext.Net" Assembly="Ext.Net" TagPrefix="ext" %>
<!DOCTYPE html>
<html>
<head runat="server">
    <title>PrintPage</title>
    <script runat="server">
        public class Org
        {
            public string ID { get; set; }
            public string Name { get; set; }
            public string ShortName { get; set; }
            public string Charger { get; set; }
            public string Telephone { get; set; }
            public string Email { get; set; }
            public string Address { get; set; }
            public string Description { get; set; }
            public DateTime CreateDate { get; set; }
        }
        public class Employee
        {
            public string Name { get; set; }
            public string Sex { get; set; }
            public int Age { get; set; }
            public string TEL { get; set; }
            public string Address { get; set; }
        }

        public void Page_Load(object sender, EventArgs e)
        {
            List<Org> orgList = new List<Org>();
            for (int i = 0; i < 32; i++)
            {
                var org = new Org
                {
                    ID = string.Format("{0:D6}", i),
                    Name = string.Format("机构{0}", i + 1),
                    ShortName = string.Format("Org{0}", i + 1),
                    Address = string.Format("南京路{0}号", i + 1),
                    Charger = string.Format("张{0}", i + 1),
                    Email = string.Format("rpoplar{0}@163.com", i + 1),
                    Telephone = string.Format("13{0}9384978493", i + 1),
                    Description = string.Format("暂无描述{0}", i + 1),
                    CreateDate = DateTime.Now.Date,

                };
                orgList.Add(org);
            }

            List<Employee> employeeList = new List<Employee>();
            for (int i = 0; i < 30; i++)
            {
                Employee em = new Employee()
                {
                    Name = string.Format("张{0}三", i),
                    Sex = i % 2 == 0 ? "男" : "女",
                    Age = i + 20,
                    Address = "南京路" + i + "号",
                    TEL = string.Format("028-66348{0:d2}", i)
                };
                employeeList.Add(em);
            }
            this.store.DataSource = orgList;
            this.store.DataBind();

            this.emStore.DataSource = employeeList;
            this.emStore.DataBind();
        }
    </script>
    <script type="text/javascript" src="../../Scripts/Print.js?v=1.0.0.0"></script>
    <script type="text/javascript">
        function Print() {
            var title = "部门机构信息列表";
            var begin = '';
            var header = ' ';
            var footer = '制表人：Rpoplar          2012-08-02';
            var grids = [grid, employGrid];
            var gridNames = ['机构信息表', '机构人员表'];
            var approveRecord = new Array();
            var record = new Object();
            for (var i = 0; i < 20; i++) {
                record.ImagePath = "../../signature.gif";
                record.Name = "张三" + i;
                record.Date = '2012-11-20';
                record.Content = "同意" + i;
                approveRecord.push(record);
            }
            preview(grids, title, begin, header, footer, gridNames, approveRecord);
        }
        function showTip(v, p) {
            //p 单元格， v单元格值；
            p.attr = 'ext:qtitle="详细："';
            p.attr += 'ext:qtip="' + v + '"';
            return v;
        }
    </script>
</head>
<body>
    <ext:ResourceManager runat="server" />
    <ext:Store runat="server" ID="store" AutoLoad="true">
        <Reader>
            <ext:JsonReader>
                <Fields>
                    <ext:RecordField Name="ID" />
                    <ext:RecordField Name="Name" />
                    <ext:RecordField Name="ShortName" />
                    <ext:RecordField Name="CreateDate" />
                    <ext:RecordField Name="Charger" />
                    <ext:RecordField Name="Telephone" />
                    <ext:RecordField Name="Email" />
                    <ext:RecordField Name="Address" />
                    <ext:RecordField Name="Description" />
                </Fields>
            </ext:JsonReader>
        </Reader>
    </ext:Store>
    <ext:Store runat="server" ID="emStore" AutoLoad="true">
        <Reader>
            <ext:JsonReader>
                <Fields>
                    <ext:RecordField Name="Name" />
                    <ext:RecordField Name="Age" />
                    <ext:RecordField Name="Sex" />
                    <ext:RecordField Name="TEL" />
                    <ext:RecordField Name="Address" />
                </Fields>
            </ext:JsonReader>
        </Reader>
    </ext:Store>
    <ext:Viewport runat="server" Layout="fit">
        <Items>
            <ext:Panel ID="panel" runat="server" Layout="RowLayout" Cls="mycss" Region="Center">
                <Items>
                    <ext:RowLayout runat="server">
                        <Rows>
                            <ext:LayoutRow RowHeight="0.5">
                                <ext:GridPanel ID="grid" StoreID="store" Title="机构列表" runat="server" Header="true">
                                    <TopBar>
                                        <ext:Toolbar runat="server">
                                            <Items>
                                                <ext:Button runat="server" Text="打 印" OnClientClick="Print()" />
                                            </Items>
                                        </ext:Toolbar>
                                    </TopBar>
                                    <ColumnModel runat="server">
                                        <Columns>
                                            <ext:Column Tooltip="ID" Header="ID" DataIndex="ID">
                                                <Renderer Fn="showTip" />
                                            </ext:Column>
                                            <ext:Column Tooltip="Name" Header="Name" DataIndex="Name">
                                                <Renderer Fn="showTip" />
                                            </ext:Column>
                                            <ext:Column Tooltip="ShortName" Header="ShortName" DataIndex="ShortName">
                                                <Renderer Fn="showTip" />
                                            </ext:Column>
                                            <ext:Column Tooltip="CreateDate" Header="CreateDate" DataIndex="CreateDate">
                                                <Renderer Fn="showTip" />
                                            </ext:Column>
                                            <ext:Column Tooltip="Charger" Header="Charger" DataIndex="Charger">
                                                <Renderer Fn="showTip" />
                                            </ext:Column>
                                            <ext:Column Tooltip="Telephone" Header="Telephone" DataIndex="Telephone">
                                                <Renderer Fn="showTip" />
                                            </ext:Column>
                                            <ext:Column Tooltip="Email" Header="Email" DataIndex="Email">
                                                <Renderer Fn="showTip" />
                                            </ext:Column>
                                            <ext:Column Tooltip="Address" Header="Address" DataIndex="Address">
                                                <Renderer Fn="showTip" />
                                            </ext:Column>
                                            <ext:Column Tooltip="Description" Header="Description" DataIndex="Description">
                                                <Renderer Fn="showTip" />
                                            </ext:Column>
                                        </Columns>
                                    </ColumnModel>
                                </ext:GridPanel>
                            </ext:LayoutRow>
                            <ext:LayoutRow RowHeight="0.5">
                                <ext:GridPanel runat="server" ID="employGrid" Title="人员列表" StoreID="emStore">
                                    <ColumnModel runat="server">
                                        <Columns>
                                            <ext:Column DataIndex="Name" Header="姓名" />
                                            <ext:Column DataIndex="Age" Header="年龄" />
                                            <ext:Column DataIndex="Sex" Header="性别" />
                                            <ext:Column DataIndex="TEL" Header="电话" />
                                            <ext:Column DataIndex="Address" Header="地址" />
                                        </Columns>
                                    </ColumnModel>
                                </ext:GridPanel>
                            </ext:LayoutRow>
                        </Rows>
                    </ext:RowLayout>
                </Items>
            </ext:Panel>
        </Items>
    </ext:Viewport>
</body>
</html>
